#include <windows.h>
#include <string.h>
#include <stdio.h>

#define BOOTLABEL "BOOTDISK"

int ModifyBootSector(int drive){

  char buffer[512];
  HANDLE hDevice ;
  DWORD bytesread;
  int res=1;
  char _devicename[] = "\\\\.\\A:";

  _devicename[4] += drive;

  hDevice = CreateFile(_devicename,  GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ | FILE_SHARE_WRITE, NULL, OPEN_EXISTING, 0, NULL);

  if (hDevice == INVALID_HANDLE_VALUE)  return 0;

  SetFilePointer (hDevice, 0, NULL, FILE_BEGIN);

  if (!ReadFile (hDevice, &buffer, 512, &bytesread, NULL) ) { printf("error: cannot read boot sector");  res= 0;}

  else {

    memcpy(buffer+0x40, BOOTLABEL, strlen(BOOTLABEL));

    SetFilePointer (hDevice, 0, NULL, FILE_BEGIN);

   if (!WriteFile (hDevice, &buffer, 512, &bytesread, NULL) )  { printf("error: cannot write boot sector");  res= 0;}
  }

  CloseHandle(hDevice);

  return res;
}

int main(int argc, char **argv){
 int drive;
 char c;

 if ((argc!=2) || (argv[1][1]!=':') || !isalpha(argv[1][0])) { printf("usage: bootable.exe <drive:>\n"); return 1;}

 drive=toupper(argv[1][0])-'A';
 
 printf("Are you sure <y/n>?: ");
 c=getchar();
 if (toupper(c)=='Y')  return ModifyBootSector(drive) ? 0 : 3;

 return 2;
}
